#######################################################################################
#######################################################################################
package Pagina;
use strict;

sub new {
	my $type = shift;
	my $class = ref($type) || $type;
	my $self = { };

	my %param = @_;

   	$self->{titulo}     = $param{-titulo} 	|| "";
   	$self->{menu}       = $param{-menu}   	|| "";
	$self->{refresh}	= $param{-refresh}	|| "";
	$self->{css}		= $param{-css}		|| "Web.css";
	$self->{picklist}	= $param{-picklist}	|| undef;


	bless ($self, $class);
	return $self;
}


sub iniciar {
	my $self = shift;
	my %param = @_;
    $self->{titulo}     = $param{-titulo}	|| $self->{titulo};
    $self->{menu}       = $param{-menu}		|| $self->{menu};
	$self->{refresh}    = $param{-refresh}	|| $self->{refresh};
	$self->{picklist}   = $param{-picklist} || undef;

}



sub abrir {
	my $self	= shift;
	my $html 	= "";
	my $onload	= "";

	$html .= "Content-type: text/html\n\n";
	$html .= "<html>\n\n";
	$html .= "<head>\n";
	$html .= "<title>$self->{titulo}</title>\n";
	$html .= "<script language=javascript src=picklist.js ></script>\n" if defined $self->{picklist};
	($self->{refresh}) && ($html .= "<meta http-equiv=refresh content=$self->{refresh}>\n");
	$html .= "<link rel=stylesheet href=$self->{css}>\n" if defined $self->{css};
	if ($self->{menu} ne "no") {
		$html .= "<link rel=stylesheet href=menu.css>\n";
		$html .= "<script language=JavaScript src=menu.js></script>\n";
	}
	$html .= "</head>\n\n";

	if ($self->{picklist}) {
		$onload .= "onLoad=\"setupPicklist(document.Formulario.".$self->{picklist}."); ";
		$onload .= "setTimeout('document.Formulario.".$self->{picklist}.".focus()',1);\" ";
	}

	if ($self->{menu} ne "no") {
		$html .= "<body ";
		$html .= $onload;
		$html .= "leftmargin=0 marginheight=0 marginwidth=0 topmargin=40>\n";
		$html .= "<script language='JavaScript'> new menu(MENU_ISP, MENU_POS, MENU_STYLES)</script>\n";
	} else {
		$html .= "<body ";
		$html .= $onload;
		$html .= "leftmargin=0 marginheight=0 marginwidth=0 topmargin=0>\n";
	}
	$html .= "<center>\n";

	print $html;
}


sub cerrar {
	my $self = shift;
	my $html = "";

	$html .= "\n</center>\n";
	$html .= "</body>\n\n";
	$html .= "</html>\n";

	print $html;
}



sub iframe {
	my $self = shift;
	my %param = @_;

	$self->{nombre}	= $param{-nombre}	|| "frameX";
	$self->{ancho}	= $param{-ancho}	|| "document.body.clientWidth";
	$self->{alto}	= $param{-alto}		|| "document.body.clientHeight";
	$self->{src}	= $param{-src}		|| "''";

	print qq~
    <script languaje=JavaScript>
    var HTML='';
    var H=$self->{alto};
    var W=$self->{ancho};
    HTML += "<table width="+(W+2)+" bgcolor=black border=0 cellspacing=0 cellpadding=1>";
    HTML += "<tr><td>";
    HTML += "<table border=0 width="+W+" cellspacing=0 cellpadding=0>";
	HTML += "<tr>";
	HTML += "<td height="+H+">";
	HTML += "<iframe name=$self->{nombre} src=$self->{src} width=100% height=100% scrolling=yes frameborder=0>";
	HTML += "</iframe>";
	HTML += "</td></tr>";
    HTML += "</table>";
    HTML += "</td></tr>";
    HTML += "</table>";
    document.write(HTML);
    </script>
	~;
}


sub iframe2 {
	my $self 	= shift;
	my %param	= @_;

    $self->{ancho}		= $param{-ancho}	|| "document.body.clientWidth";
	$self->{nombre1}	= $param{-nombre1}	|| "frameX1";
	$self->{nombre2}	= $param{-nombre2}	|| "frameX2";
    $self->{alto1}		= $param{-alto1}	|| "45";
    $self->{alto2}		= $param{-alto2}	|| "100";
    $self->{src1}		= $param{-src1}		|| "''";
    $self->{src2}		= $param{-src2}		|| "''";

    print qq~
    <script languaje=JavaScript>
    var HTML='';
    var X=document.body.clientWidth;
    var Y=document.body.clientHeight;
    var H1=$self->{alto1};
    var H2=$self->{alto2};
    var  W=$self->{ancho};
    HTML += "<table width="+(W+2)+" bgcolor=black border=0 cellspacing=0 cellpadding=1>";
    HTML += "<tr><td>";
    HTML += "<table border=0 width="+W+" cellspacing=0 cellpadding=0>";
    HTML += "<tr><td height="+H1+">";
	HTML += "<iframe name=$self->{nombre1} src=$self->{src1} width=100% height=100% scrolling=yes frameborder=0>";
	HTML += "</iframe>";
	HTML += "</td></tr>";
    HTML += "<tr><td height="+H2+">";
	HTML += "<iframe name=$self->{nombre2} src=$self->{src2} width=100% height=100% frameborder=0 scrolling=yes>";
	HTML += "</iframe>";
	HTML += "</td></tr>";
    HTML += "</table>";
    HTML += "</td></tr>";
    HTML += "</table>";
    document.write(HTML);
    </script>
    ~;

}


sub iframe3 {
    my $self    = shift;
    my %param   = @_;
    
    $self->{ancho}		= $param{-ancho}	|| "document.body.clientWidth";
    $self->{alto1}		= $param{-alto1}	|| "45";
    $self->{alto2}		= $param{-alto2}	|| "100";
    $self->{alto3}		= $param{-alto3}	|| "45";
    $self->{src1}		= $param{-src1}		|| "''";
    $self->{src2}		= $param{-src2}		|| "''";
    $self->{src3}		= $param{-src3}		|| "''";
	$self->{nombre1}	= $param{-nombre1}	|| "frameX1";
	$self->{nombre2}	= $param{-nombre2}	|| "frameX2";
	$self->{nombre3}	= $param{-nombre3}	|| "frameX3";
	$self->{pie}		= $param{-pie}		|| undef;
	$self->{altopie}	= $param{-altopie}	|| "45";
	$self->{srcpie}		= $param{-srcpie}	|| "''";
    
    print qq~
    <script languaje=JavaScript>
    var HTML='';
    var X=document.body.clientWidth;
    var Y=document.body.clientHeight;
    var H1=$self->{alto1};
    var H2=$self->{alto2};
    var H3=$self->{alto3};
	~;

	if ($self->{pie}) {
		print qq~
		var Hpie=$self->{altopie};
		~;
	}

	print qq~
    var  W=$self->{ancho};
	HTML += "<table width="+(W+2)+" bgcolor=black border=0 cellspacing=0 cellpadding=1>";
	HTML += "<tr><td>";
    HTML += "<table border=0 width="+W+" cellspacing=0 cellpadding=0>";
    HTML += "<tr><td height="+H1+">";
    HTML += "<iframe name=$self->{nombre1} src=$self->{src1} width=100% height=100% frameborder=0 scrolling=yes>";
    HTML += "</iframe>";
    HTML += "</td></tr>";
    HTML += "<tr><td height="+H2+">";
    HTML += "<iframe name=$self->{nombre2} src=$self->{src2} width=100% height=100% frameborder=0 scrolling=yes>";
    HTML += "</iframe>";
    HTML += "</td></tr>";
    HTML += "<tr><td height="+H3+">";
    HTML += "<iframe name=$self->{nombre3} src=$self->{src3} width=100% height=100% frameborder=0 scrolling=yes>";
    HTML += "</iframe>";
    HTML += "</td></tr>";
	~;

	if ($self->{pie}) {
		print qq~
    	HTML += "<tr><td height="+Hpie+">";
	    HTML += "<iframe name=$self->{pie} src=$self->{srcpie} width=100% height=100% frameborder=0 scrolling=no>";
    	HTML += "</iframe>";
	    HTML += "</td></tr>";
		~;
	}

	print qq~
    HTML += "</table>";
	HTML += "</td></tr>";
	HTML += "</table>";
    document.write(HTML);
    </script>
    ~;
    
}   
#######################################################################################
#######################################################################################
#######################################################################################
#######################################################################################
#######################################################################################
#######################################################################################
package Input;
use strict;

sub new {
    my $type	= shift;
    my $class	= ref($type) || $type;
    my $self	= {};
	
	$self->{tipo}	=	{ 
		"button" 	=>	"<input type=button ",
		"checkbox"	=>	"<input type=checkbox ",
		"file"		=>	"<input type=file ",
		"hidden"	=>	"<input type=hidden ",
		"image"		=>	"<input type=image ",
		"password"	=>	"<input type=password ",
		"radio"		=>	"<input type=radio ",
		"reset"		=>	"<input type=reset ",
		"submit"	=>	"<input type=submit ",
		"text"		=>	"<input type=text "
	};

	my %param = @_;

	$self->{type}		=	$param{-type}		||	"text"; 
	$self->{id}			=	$param{-id}			||	undef;
	$self->{name}		=	$param{-name}		||	undef;
	$self->{value}		=	$param{-value}		||	undef;
	$self->{size}		=	$param{-size}		||	undef;
	$self->{maxlen}		=	$param{-maxlen}		||	undef;
	$self->{src}		=	$param{-src}		||	undef;
	$self->{readonly}	=	$param{-readonly}	||	undef;
	$self->{checked}	=	$param{-checked}	||	undef;
	$self->{tabindex}	=	$param{-tabindex}	||	undef;
	$self->{border}		=	$param{-border}		||	undef;
	$self->{estilo}		=	$param{-estilo}		||	undef;
	$self->{etiqueta}	=	$param{-etiqueta}	||	undef;

    bless($self, $class);
	return $self;
}


sub codigo {
	my $self = shift;
	my $html = "";

	$html .= $self->{tipo}{$self->{type}};
	$html .= " id=$self->{id}" if defined $self->{id};
	$html .= " name=$self->{name}" if defined $self->{name};
	$html .= " value='".$self->{value}."'" if defined $self->{value};
	$html .= " maxlength=$self->{maxlen}" if defined $self->{maxlen};
	$html .= " size=$self->{size}" if defined $self->{size};
	$html .= " border=$self->{border}" if defined $self->{border};
	$html .= " src=$self->{src}" if defined $self->{src};
	$html .= " readonly" if defined $self->{readonly};
	$html .= " checked" if defined $self->{checked};
	$html .= " tabindex=$self->{tabindex}" if defined $self->{tabindex};
	$html .= ">";
	$html .= "$self->{etiqueta}" if defined $self->{etiqueta};

	return $html;
}
#######################################################################################
#######################################################################################
#######################################################################################
#######################################################################################
#######################################################################################
#######################################################################################
package Select;
use strict;

sub new {
    my $type    = shift;
    my $class   = ref($type) || $type;
    my $self    = {};

	my %param			= @_;
	$self->{name}		= $param{-name}		|| "selector";
	$self->{size}		= $param{-size}		|| undef;
	$self->{multiple}	= $param{-multiple} || undef;

	$self->{opcion}		= {};
	$self->{value}		= {};
	$self->{selected}	= {};
	$self->{opciones}	= 0;

    bless($self, $class);
    return $self;
}


sub insertar {
    my $self 		= shift;
	my %param 		= @_;

    $self->{opciones}++;
	my $i = $self->{opciones};

	$self->{opcion}{$i} 	= $param{-opcion};
	$self->{value}{$i}		= $param{-value} || $self->{opcion}{$i};
	$self->{selected}{$i}	= "ok" if defined $param{-selected};
}


sub codigo {
	my $self = shift;
	my $html = "";

	$html .= "\n	<select name=$self->{name}";
	$html .= " size=$self->{size}" if defined $self->{size};
	$html .= " multiple" if defined $self->{multiple};
	$html .= ">\n";
	
	for (my $j=1; $j <= $self->{opciones}; $j++) {
		$html .= "		<option";
		$html .= " value=$self->{value}{$j}" if defined $self->{value}{$j};
		$html .= " selected" if defined $self->{selected}{$j};
		$html .= ">$self->{opcion}{$j}</option>\n"
	}

	$html .= "	</select>\n";
	
	return $html;
}
#######################################################################################
#######################################################################################
#######################################################################################
#######################################################################################
#######################################################################################
#######################################################################################
package Formulario;
use strict;

sub new {
	my $type = shift;
	my $class = ref($type) || $type;
	my $self ={};

    my %param = @_; 
    $self->{nombre}			= $param{-nombre}  			|| undef;
    $self->{titulo}			= $param{-titulo}  			|| "";
    $self->{subtitulo}		= $param{-subtitulo}		|| "";
    $self->{id}				= $param{-id}				|| "formulario";
    $self->{ancho}			= $param{-ancho}			|| "80%";
    $self->{borde}			= $param{-borde}			|| "si";
    $self->{action}			= $param{-action}			|| "nada.cgi";
    $self->{target}			= $param{-target}			|| "_self";
    $self->{botones}		= $param{-botones}			|| "si";
    $self->{submit}			= $param{-submit}       	|| "ACEPTAR";
    $self->{cancel}			= $param{-cancel}        	|| "CANCELAR";
    $self->{reset}			= $param{-reset}        	|| "LIMPIAR";
    $self->{confirmar}			= $param{-confirmar}		|| "";
    $self->{cancel_action}	= $param{-cancel_action} 	|| "nada.cgi";
    $self->{cancel_target}	= $param{-cancel_target} 	|| $self->{target};
    $self->{br}				= $param{-br};

	$self->{celda} = {};
	$self->{filas} = 0;
	$self->{columnas} = {};
	$self->{maxcol} =1;	

	bless($self, $class);

    return $self;
}   
    
    
sub insertar {
	my $self = shift;
   	my $count = @_;

	$self->{filas}++;

	my $fila	= $self->{filas};
	my $celda	= "";

   	for (my $columna=1; $columna <= $count; $columna++) {
    	$celda	= shift;
		$self->{celda}{"$fila:$columna"} = $celda;

	}

   	($self->{columnas}{$fila} < $count) && ($self->{columnas}{$fila} = $count);
	($self->{maxcol} < $count) && ($self->{maxcol}=$count);
   
}


sub codigo {
	my $self		= shift;
	my $html		= "";
	my $filas 		= $self->{filas};
	my $colspan		= $self->{maxcol};
	my $celda 		= "";
	my $width		= $self->{ancho};

	($self->{br}) && ($html .= "<br>");

	if ($self->{borde} eq "si") {
		$html .= "<table width=$self->{ancho} bgcolor=black border=0 cellspacing=0 cellpadding=1>\n";
		$html .= "<tr><td>\n";
		$width = "100%";
	}

	$html .= "<table width=$width class=formulario border=0 cellspacing=2 cellpadding=2 id=$self->{id}>\n";


	my $OnSubmit = "";
	
	if ($self->{confirmar} ne "") {
		$OnSubmit = "OnSubmit='return confirm(\"".$self->{confirmar}."\");'\n";
	}
			

	$html .= "<form";
	$html .= " name=".$self->{nombre} if defined $self->{nombre};
	$html .= " action=\"$self->{action}\" target=$self->{target} method=post $OnSubmit>\n";

	($self->{titulo})    && ($html .= "<tr><td colspan=$colspan class=formulario-titulo>$self->{titulo}</td></tr>\n");;
	($self->{subtitulo}) && ($html .= "<tr><td colspan=$colspan class=formulario-subtitulo>$self->{subtitulo}</td></tr>\n");

	# $html .= "<tr><td colspan=$colspan>&nbsp;</td></tr>\n";


	$colspan=1;

	for (my $fila=1; $fila <= $filas; $fila++) {
		$html .= "<tr>\n";
		for (my $columna=1; $columna <= $self->{columnas}{$fila}; $columna++) {
			$colspan = 1;
			if ( ($columna == $self->{columnas}{$fila}) && ($self->{columnas}{$fila} < $self->{maxcol}) ) {
				$colspan = 1 + $self->{maxcol} - $columna;
			} 
			$celda = $self->{celda}{"$fila:$columna"}->codigo;
			$html .= "<td colspan=$colspan ";
			if ($self->{celda}{"$fila:$columna"}->{estilo}) {
				$html .= "class=".$self->{celda}{"$fila:$columna"}->{estilo};
			}
			$html .= " id='r$fila:c$columna'>".$celda."</td>\n";
		}
		$html .= "</tr>\n\n";
	}


	$colspan     = $self->{maxcol};

	# $html .= "<tr><td colspan=$colspan>&nbsp;</td></tr>\n";


	
	if ($self->{botones} ne "no") {

		$html .= "<tr>\n\n";
		$html .= "<td colspan=$colspan>\n";
		
		    

		# Tabla con botones
		$html .= "  <table class=formulario-pie border=0 width=100%>\n";
		$html .= "  <tr>\n";

		# Boton OK
		("\U$self->{botones}" eq "SOLOSUBMIT") ? (my $w = "100%") : (my $w = "50%");
		$html .= "  <td width=$w align=center>\n";
		$html .= "  <input type=Submit name=$self->{submit} value=$self->{submit} size=100 $OnSubmit>\n";
		$html .= "  </td>\n";
		$html .= "  </form>\n";

	# Boton Cancelar
		if ("\U$self->{botones}" ne "SOLOSUBMIT") {
			$html .= "  <form action=$self->{cancel_action} method=post target=$self->{cancel_target}>\n";
			$html .= "  <td width=50% align=center>\n";
			$html .= "  <input type=Submit name=$self->{cancel} value=$self->{cancel} size=100>\n";
			$html .= "  </td>\n";
			$html .= "  </form>\n";
		}

		$html .= "  </tr>\n";
		$html .= "  </table>\n";
	
		$html .= "</td>\n";
		$html .= "</tr>\n\n";

	}

	$html .= "</table>\n\n";

	
	if ($self->{borde} eq "si") {
		$html .= "</td></tr>\n";
		$html .= "</table>";
	}
	
	return $html;
}



sub mostrar{
	my $self = shift;
	my $html = $self->codigo;
	print $html;
}
#######################################################################################
#######################################################################################
#######################################################################################
#######################################################################################
#######################################################################################
#######################################################################################
package InputFecha;
use strict;



sub new {
    my $type    = shift;
    my $class   = ref($type) || $type;
    my $self    = {};

	$self->{tipo}		= "InputFecha";

    my %param           = @_;
    $self->{nombre}     = $param{-nombre}   || "fecha";
    $self->{y0}			= $param{-y0}		|| undef;

	$self->{dia}		= Select->new(-name=>"dia_".$self->{nombre});
	$self->{mes}		= Select->new(-name=>"mes_".$self->{nombre});
	$self->{anio}		= Select->new(-name=>"anio_".$self->{nombre});

	$self->{dia}->insertar(-opcion=>"&nbsp;");
	for (my $d=1; $d <= 31; $d++) {
		(length($d) < 2) && ($d = "0".$d);
		$self->{dia}->insertar(-opcion=>$d);
	}

	$self->{mes}->insertar(-opcion=>"&nbsp;");
	for (my $m=1; $m <= 12; $m++) {
		(length($m) < 2) && ($m = "0".$m);
		$self->{mes}->insertar(-opcion=>$m);
	}

	open (Y, "date +%Y |");
	my $anio_hoy=<Y>;
	close (Y);

	$self->{anio}->insertar(-opcion=>"&nbsp;");
	for (my $y=2002; $y <= $anio_hoy; $y++) {
		$self->{anio}->insertar(-opcion=>$y);
	}

    bless($self, $class);
    return $self;
}



sub codigo {
    my $self        = shift;
    my $html        = "";
	my $sep			= "";
 
	$html .= $self->{dia}->codigo.$sep.$self->{mes}->codigo.$sep.$self->{anio}->codigo;

}
#######################################################################################
#######################################################################################
#######################################################################################
#######################################################################################
#######################################################################################
#######################################################################################
package Label;
use strict;
    
sub new {
    my $type    = shift;
    my $class   = ref($type) || $type;
    my $self    = {};   
    
	$self->{tipo}		=	"Etiqueta";

	my %param	= @_;

    $self->{estilo}     =   $param{-estilo}		|| "formulario-etiqueta";
	$self->{text}		=	$param{-text};

    bless($self, $class);
    return $self;
}


sub codigo {
    my $self = shift;
    return $self->{text};
}
#######################################################################################
#######################################################################################
#######################################################################################
#######################################################################################
#######################################################################################
#######################################################################################
package Boton;
use strict;

sub new {
    my $type    = shift;
    my $class   = ref($type) || $type;
    my $self    = {};
	my $html	= "";

    my %param   = @_;

	$self->{tipo}		=	$param{-tipo}	||	"submit";
	$self->{nombre}		=	$param{-nombre}	||	"boton";
    $self->{texto}      =   $param{-texto}	||	"enviar";
	$self->{size}		=	$param{-size}	||	"100";
	$self->{codigo}		=	"";

    bless($self, $class);
    return $self;
}

sub codigo {
    my $self	= shift;
	my $html	= "";
	
	$html		= "<input type=$self->{tipo} name=$self->{nombre} value=$self->{texto} size=$self->{size}>\n";
	return $html;
}

sub mostrar {
	my $self	= shift;

	print $self->{codigo};
}
#######################################################################################
#######################################################################################
#######################################################################################
#######################################################################################
#######################################################################################
#######################################################################################
package InputMacAddr; 
use strict;
        
sub new {
    my $type    = shift;
    my $class   = ref($type) || $type;
    my $self    = {};

    my %param           = @_;

	for (my $i=1; $i <= 6; $i++) {
		$self->{$i}		= Input->new(-name=>"mac".$i, -size=>1, -maxlen=>2, -border=>0, -estilo=>"lista-celda");
	}

    bless($self, $class);
    return $self;
}



sub codigo {
    my $self        = shift;
    my $html        = "";

    $html .= $self->{1}->codigo.":";
    $html .= $self->{2}->codigo.":";
    $html .= $self->{3}->codigo.":";
    $html .= $self->{4}->codigo.":";
    $html .= $self->{5}->codigo.":";
    $html .= $self->{6}->codigo;

	return $html;

}


sub mostrar {
    my $self        = shift;
	print $self->codigo;
}
#######################################################################################
#######################################################################################
#######################################################################################
#######################################################################################
#######################################################################################
#######################################################################################
package Tabla;


sub new {
    my $type    = shift;
    my $class   = ref($type) || $type;
    my $self    = {};

    my %param = @_;
    $self->{titulo}         = $param{-titulo}           || "";
    $self->{subtitulo}      = $param{-subtitulo}        || "";
    $self->{ancho}          = $param{-ancho}            || "80%";
    $self->{borde}          = $param{-borde}            || "si";

    $self->{celda} = {};
    $self->{filas} = 0;
    $self->{columnas} = {};
    $self->{maxcol} =1;

    bless($self, $class);
    return $self;
}


sub insertar {
    my $self = shift;

    my %param = @_;
    $self->{class}         = $param{-class}		|| "";

    $self->{filas}++;

    my $esta_fila    = $self->{filas};
    my $esta_celda   = "";

}


sub codigo {


}


sub mostrar {


}
#######################################################################################
#######################################################################################
#######################################################################################
#######################################################################################
#######################################################################################
#######################################################################################
#######################################################################################
#######################################################################################
#######################################################################################
#######################################################################################
#######################################################################################
#######################################################################################
1;

