-- MySQL dump 8.22
--
-- Host: localhost    Database: isp
---------------------------------------------------------
-- Server version	3.23.54


USE isp;

CREATE TABLE IF NOT EXISTS config (
  id int(11) unsigned NOT NULL auto_increment,
  parametro varchar(128) NOT NULL,
  valor varchar(250) NOT NULL,
  PRIMARY KEY (id),
  UNIQUE KEY parametro (parametro)
) TYPE=MyISAM;


INSERT INTO config VALUES ('', 'compania', '') ON DUPLICATE KEY UPDATE parametro=parametro;
INSERT INTO config VALUES ('', 'dominio_principal', '') ON DUPLICATE KEY UPDATE parametro=parametro;


CREATE TABLE IF NOT EXISTS abonos (
  id int(11) unsigned NOT NULL auto_increment,
  nombre varchar(30) NOT NULL default '',
  tiempo int(5) default NULL,
  abono decimal(6,2) unsigned NOT NULL default '0.00',
  excedente decimal(5,2) default '0.00',
  PRIMARY KEY  (id),
  UNIQUE KEY nombre (nombre)
) TYPE=MyISAM;


CREATE TABLE IF NOT EXISTS clientes (
  id int(11) NOT NULL auto_increment,
  nombre varchar(100) default NULL,
  apellido varchar(100) NOT NULL default '',
  domicilio varchar(250) default NULL,
  telefono varchar(15) default NULL,
  email varchar(50) default NULL,
  PRIMARY KEY  (id)
) TYPE=MyISAM;


CREATE TABLE IF NOT EXISTS dialup_users (
  id int(11) unsigned NOT NULL auto_increment,
  username varchar(128) NOT NULL default '',
  password varchar(64) NOT NULL default '',
  callback int(20) default NULL,
  filtro varchar(20) default NULL,
  cliente_id int(11) unsigned default NULL,
  abono_id int(11) unsigned default NULL,
  PRIMARY KEY  (id),
  UNIQUE KEY username (username)
) TYPE=MyISAM;


CREATE TABLE IF NOT EXISTS periodos (
  id int(11) unsigned NOT NULL auto_increment,
  periodo char(7) binary default NULL,
  PRIMARY KEY (id)
) TYPE=MyISAM;


CREATE TABLE IF NOT EXISTS dominios (
  id int(11) unsigned NOT NULL auto_increment,
  dominio varchar(132) NOT NULL,
  password varchar(64) NOT NULL,
  bloqueado set ('s', 'n') default 'n',
  cliente_id int(11) unsigned NOT NULL,
  perfil_id int(11) unsigned NOT NULL,
  PRIMARY KEY (id),
  UNIQUE KEY dominio (dominio)
) TYPE=MyISAM;

--
-- Table structure for table 'AdminMenu'
--

CREATE TABLE IF NOT EXISTS AdminMenu (
  id int(5) unsigned NOT NULL auto_increment,
  label varchar(32) NOT NULL default '',
  link varchar(128) NOT NULL default '',
  level int(3) NOT NULL default '0',
  PRIMARY KEY  (id),
  UNIQUE KEY label (label)
) TYPE=MyISAM;

--
-- Table structure for table 'AdminUsers'
--

CREATE TABLE IF NOT EXISTS AdminUsers (
  id int(4) NOT NULL auto_increment,
  usuario varchar(30) default NULL,
  contra varchar(30) default NULL,
  tipo varchar(30) default NULL,
  PRIMARY KEY id (id),
  UNIQUE KEY ix_usuario (usuario)
) TYPE=MyISAM;

--
-- Table structure for table 'BroadBandUsers'
--

CREATE TABLE IF NOT EXISTS BroadBandUsers (
  id int(5) unsigned NOT NULL auto_increment,
  username varchar(128) NOT NULL default '',
  password varchar(128) NOT NULL default '',
  enabled set('y','n') default 'y',
  client_id int(5) NOT NULL default '0',
  cpe_id int(5) NOT NULL default '0',
  mac varchar(17) NOT NULL default '',
  ip varchar(15) NOT NULL default '',
  dev varchar(4) NOT NULL default '',
  dhcpd_focus varchar(128) NOT NULL default '',
  DwCIR int(5) NOT NULL default '0',
  DwMIR int(5) NOT NULL default '0',
  UpCIR int(5) NOT NULL default '0',
  UpMIR int(5) NOT NULL default '0',
  class_id int(5) NOT NULL default '0',
  tc_add_script text,
  tc_del_script text,
  PRIMARY KEY  (id),
  UNIQUE KEY username (username)
) TYPE=MyISAM;

--
-- Table structure for table 'CPEs'
--

CREATE TABLE IF NOT EXISTS CPEs (
  id int(5) NOT NULL auto_increment,
  mac varchar(17) NOT NULL default '',
  ip varchar(15) NOT NULL default '',
  cpe_type_id int(5) default NULL,
  sitio varchar(128) default NULL,
  admin_user varchar(30) default NULL,
  admin_pass varchar(30) default NULL,
  PRIMARY KEY  (id),
  UNIQUE KEY mac (mac)
) TYPE=MyISAM;

--
-- Table structure for table 'CpeTypes'
--

CREATE TABLE IF NOT EXISTS CpeTypes (
  id int(5) NOT NULL auto_increment,
  marca varchar(128) NOT NULL default '',
  modelo varchar(128) NOT NULL default '',
  tipo set('A','W') default NULL,
  gestionable set('y','n','Y','N') default 'y',
  web set('y','n','Y','N') default 'y',
  telnet set('y','n','Y','N') default 'y',
  snmp set('y','n','Y','N') default 'y',
  ro_community varchar(50) default NULL,
  rw_community varchar(50) default NULL,
  proxea_mac set('y','n','Y','N') default 'y',
  PRIMARY KEY  (id),
  UNIQUE KEY cpe (marca,modelo)
) TYPE=MyISAM;

--
-- Table structure for table 'IPs'
--

CREATE TABLE IF NOT EXISTS IPs (
  id int(11) unsigned NOT NULL auto_increment,
  ip varchar(15) NOT NULL default '',
  dev varchar(4) default NULL,
  net set('devices','clients') default NULL,
  netname varchar(128) NOT NULL default '',
  available set('y','n') default 'y',
  PRIMARY KEY  (id),
  UNIQUE KEY IP (ip)
) TYPE=MyISAM;

--
-- Table structure for table 'NetBW'
--

CREATE TABLE IF NOT EXISTS NetBW (
  id int(5) unsigned NOT NULL auto_increment,
  bw int(6) NOT NULL default '0',
  PRIMARY KEY  (id),
  UNIQUE KEY bw (bw)
) TYPE=MyISAM;

--
-- Table structure for table 'NetClasses'
--

CREATE TABLE IF NOT EXISTS NetClasses (
  id int(5) unsigned NOT NULL auto_increment,
  name varchar(128) NOT NULL default '',
  parent_major int(3) NOT NULL default '0',
  parent_minor int(3) NOT NULL default '0',
  classid_major int(3) NOT NULL default '0',
  classid_minor int(3) NOT NULL default '0',
  OutCIR int(5) NOT NULL default '0',
  OutMIR int(5) NOT NULL default '0',
  InCIR int(5) NOT NULL default '0',
  InMIR int(5) NOT NULL default '0',
  dev varchar(4) NOT NULL default '',
  PRIMARY KEY  (id),
  UNIQUE KEY classid (classid_major,classid_minor),
  UNIQUE KEY name (name)
) TYPE=MyISAM;

--
-- Table structure for table 'NetDevices'
--

CREATE TABLE IF NOT EXISTS NetDevices (
  id int(5) unsigned NOT NULL auto_increment,
  dev varchar(4) NOT NULL default '',
  alias varchar(16) default NULL,
  rate int(5) unsigned NOT NULL default '0',
  netname varchar(128) NOT NULL default '',
  ip varchar(15) NOT NULL default '',
  mask varchar(15) NOT NULL default '',
  net varchar(15) NOT NULL default '',
  prefix int(2) NOT NULL default '0',
  nated int(1) default '0',
  dhcpd_status int(1) default '0',
  users_first_ip varchar(15) NOT NULL default '',
  users_last_ip varchar(15) NOT NULL default '',
  PRIMARY KEY  (id),
  UNIQUE KEY dev_alias (dev,alias)
) TYPE=MyISAM;

--
-- Table structure for table 'NetFilters'
--

CREATE TABLE IF NOT EXISTS NetFilters (
  id int(5) unsigned NOT NULL auto_increment,
  name varchar(128) NOT NULL default '',
  parent_major int(3) NOT NULL default '0',
  parent_minor int(3) NOT NULL default '0',
  dev varchar(4) NOT NULL default '',
  protocol varchar(5) NOT NULL default 'ip',
  prio int(4) NOT NULL default '1',
  filter varchar(128) NOT NULL default '',
  flowid_major int(3) NOT NULL default '0',
  flowid_minor int(3) NOT NULL default '0',
  PRIMARY KEY  (id),
  UNIQUE KEY filter (dev,protocol,filter)
) TYPE=MyISAM;

--
-- Table structure for table 'clientes'
--

CREATE TABLE IF NOT EXISTS clientes (
  id int(11) NOT NULL auto_increment,
  nombre varchar(100) default NULL,
  apellido varchar(100) NOT NULL default '',
  domicilio varchar(250) default NULL,
  telefono varchar(15) default NULL,
  email varchar(50) default NULL,
  PRIMARY KEY  (id)
) TYPE=MyISAM;

CREATE TABLE IF NOT EXISTS radacct (
  RadAcctId bigint(21) NOT NULL auto_increment,
  AcctSessionId varchar(32) NOT NULL default '',
  AcctUniqueId varchar(32) NOT NULL default '',
  UserName varchar(64) NOT NULL default '',
  Realm varchar(64) default '',
  NASIPAddress varchar(15) NOT NULL default '',
  NASPortId int(12) default NULL,
  NASPortType varchar(32) default NULL,
  AcctStartTime datetime NOT NULL default '0000-00-00 00:00:00',
  AcctStopTime datetime NOT NULL default '0000-00-00 00:00:00',
  AcctSessionTime int(12) default NULL,
  AcctAuthentic varchar(32) default NULL,
  ConnectInfo_start varchar(32) default NULL,
  ConnectInfo_stop varchar(32) default NULL,
  AcctInputOctets bigint(12) default NULL,
  AcctOutputOctets bigint(12) default NULL,
  CalledStationId varchar(50) NOT NULL default '',
  CallingStationId varchar(50) NOT NULL default '',
  AcctTerminateCause varchar(32) NOT NULL default '',
  ServiceType varchar(32) default NULL,
  FramedProtocol varchar(32) default NULL,
  FramedIPAddress varchar(15) NOT NULL default '',
  AcctStartDelay int(12) default NULL,
  AcctStopDelay int(12) default NULL,
  PRIMARY KEY  (RadAcctId),
  KEY UserName (UserName),
  KEY FramedIPAddress (FramedIPAddress),
  KEY AcctSessionId (AcctSessionId),
  KEY AcctUniqueId (AcctUniqueId),
  KEY AcctStartTime (AcctStartTime),
  KEY AcctStopTime (AcctStopTime),
  KEY NASIPAddress (NASIPAddress)
) ;
GRANT SELECT ON isp.radacct TO radius@localhost IDENTIFIED BY "radius";


CREATE TABLE IF NOT EXISTS radcheck (
  id int(11) unsigned NOT NULL auto_increment,
  UserName varchar(64) NOT NULL default '',
  Attribute varchar(32)  NOT NULL default '',
  op char(2) NOT NULL DEFAULT '==',
  Value varchar(253) NOT NULL default '',
  PRIMARY KEY  (id),
  KEY UserName (UserName(32))
) ;
GRANT SELECT ON isp.radcheck TO radius@localhost IDENTIFIED BY "radius";


CREATE TABLE IF NOT EXISTS radgroupcheck (
  id int(11) unsigned NOT NULL auto_increment,
  GroupName varchar(64) NOT NULL default '',
  Attribute varchar(32)  NOT NULL default '',
  op char(2) NOT NULL DEFAULT '==',
  Value varchar(253)  NOT NULL default '',
  PRIMARY KEY  (id),
  KEY GroupName (GroupName(32))
) ;
GRANT SELECT ON isp.radgroupcheck TO radius@localhost IDENTIFIED BY "radius";


CREATE TABLE IF NOT EXISTS radgroupreply (
  id int(11) unsigned NOT NULL auto_increment,
  GroupName varchar(64) NOT NULL default '',
  Attribute varchar(32)  NOT NULL default '',
  op char(2) NOT NULL DEFAULT '=',
  Value varchar(253)  NOT NULL default '',
  prio int unsigned NOT NULL default '0',
  PRIMARY KEY  (id),
  KEY GroupName (GroupName(32))
) ;
GRANT SELECT ON isp.radgroupreply TO radius@localhost IDENTIFIED BY "radius";


CREATE TABLE IF NOT EXISTS radreply (
  id int(11) unsigned NOT NULL auto_increment,
  UserName varchar(64) NOT NULL default '',
  Attribute varchar(32) NOT NULL default '',
  op char(2) NOT NULL DEFAULT '=',
  Value varchar(253) NOT NULL default '',
  PRIMARY KEY  (id),
  KEY UserName (UserName(32))
) ;
GRANT SELECT ON isp.radreply TO radius@localhost IDENTIFIED BY "radius";



CREATE TABLE IF NOT EXISTS usergroup (
  id int(11) unsigned NOT NULL auto_increment,
  UserName varchar(64) NOT NULL default '',
  GroupName varchar(64) NOT NULL default '',
  PRIMARY KEY  (id),
  KEY UserName (UserName(32))
) ;
GRANT SELECT ON isp.usergroup TO radius@localhost IDENTIFIED BY "radius";


CREATE TABLE IF NOT EXISTS radpostauth (
  id int(11) NOT NULL auto_increment,
  user varchar(64) NOT NULL default '',
  pass varchar(64) NOT NULL default '',
  reply varchar(32) NOT NULL default '',
  date timestamp(14) NOT NULL,
  PRIMARY KEY  (id)
) ;
GRANT SELECT ON isp.radpostauth TO radius@localhost IDENTIFIED BY "radius";


#CREATE TABLE IF NOT EXISTS dictionary (
#  id int(10) DEFAULT '0' NOT NULL auto_increment,
#  Type varchar(30),
#  Attribute varchar(64),
#  Value varchar(64),
#  Format varchar(20),
#  Vendor varchar(32),
#  PRIMARY KEY (id)
#);
#GRANT SELECT ON isp.dictionary TO radius@localhost IDENTIFIED BY "radius";


#CREATE TABLE IF NOT EXISTS nas (
#  id int(10) DEFAULT '0' NOT NULL auto_increment,
#  nasname varchar(128) NOT NULL,
#  shortname varchar(32),
#  type varchar(30) DEFAULT 'other',
#  ports int(5),
#  secret varchar(60) DEFAULT 'secret' NOT NULL,
#  community varchar(50),
#  description varchar(200) DEFAULT 'RADIUS Client',
#  PRIMARY KEY (id),
#  KEY nasname (nasname)
#);
#GRANT SELECT ON isp.nas TO radius@localhost IDENTIFIED BY "radius";

CREATE TABLE IF NOT EXISTS postfix_access (
  id int(10) unsigned NOT NULL auto_increment,
  source varchar(128) NOT NULL default '',
  access varchar(128) NOT NULL default '',
  type enum('recipient','sender','client') NOT NULL default 'recipient',
  PRIMARY KEY  (id)
) TYPE=MyISAM;


CREATE TABLE IF NOT EXISTS postfix_aliases (
  id int(11) unsigned NOT NULL auto_increment,
  alias varchar(128) NOT NULL default '',
  destination varchar(128) NOT NULL default '',
  PRIMARY KEY  (id)
) TYPE=MyISAM;


CREATE TABLE IF NOT EXISTS postfix_relocated (
  id int(11) unsigned NOT NULL auto_increment,
  address varchar(128) NOT NULL default '',
  destination varchar(128) NOT NULL default '',
  PRIMARY KEY  (id)
) TYPE=MyISAM;


CREATE TABLE IF NOT EXISTS postfix_transport (
  id int(11) unsigned NOT NULL auto_increment,
  domain varchar(128) NOT NULL default '',
  destination varchar(128) NOT NULL default '',
  PRIMARY KEY  (id),
  UNIQUE KEY domain (domain)
) TYPE=MyISAM;


CREATE TABLE IF NOT EXISTS postfix_users (
  id int(11) unsigned NOT NULL auto_increment,
  client_id int(11) unsigned NOT NULL,
  username varchar(128) NOT NULL default '',
  address varchar(128) NOT NULL default '',
  clear varchar(128) NOT NULL default '',
  name tinytext NOT NULL,
  uid int(11) unsigned NOT NULL default '1000',
  gid int(11) unsigned NOT NULL default '1000',
  homedir tinytext NOT NULL,
  maildir tinytext NOT NULL,
  quota tinytext NOT NULL,
  access enum('Y','N') NOT NULL default 'Y',
  postfix enum('Y','N') NOT NULL default 'Y',
  PRIMARY KEY  (id),
  UNIQUE KEY username (username),
  UNIQUE KEY address (address)
) TYPE=MyISAM;


CREATE TABLE IF NOT EXISTS postfix_virtual (
  id int(11) unsigned NOT NULL auto_increment,
  address varchar(128) NOT NULL default '',
  destination varchar(128) NOT NULL default '',
  PRIMARY KEY  (id)
) TYPE=MyISAM;
