#!/usr/bin/perl

require 'AdminISP.pm';

use DBI;
my $db      = "isp";
my $host    = "localhost";
my $dbuser  = "isp";
my $dbpass  = "isp";
my $dbh     = DBI->connect("DBI:mysql:$db:$host", $dbuser, $dbpass);;
my $sth;
my $rv; 
        
use Radius;
my $radius = new Radius;
$radius->init('isp', 'isp', 'localhost', 'isp');

use CGI;
my $query       = new CGI;
my $cgi         = $query->url;
my $usuario		= $query->param('usuario');
my $clave		= $query->param('clave');
my $periodo		= $query->param('periodo');
my $desde		= $query->param('desde');
my $hasta		= $query->param('hasta');
my $detallado	= $query->param('detallado');
my $costo		= $query->param('costo');


my $where		= "";
my $sqlquery	= "";


$sqlquery  = "SELECT sum(AcctSessionTime)/60 AS minutos,";
$sqlquery .= "sum(AcctSessionTime)    AS segundos,";
$sqlquery .= "sec_to_time(sum(AcctSessionTime)) AS hms,";



print "Content-type: text/html\n\n";

if (! &UsuarioOK($usuario)) {

	redirect("/error/AdminISP/usuario_error.html");

} elsif (! &ClaveOK($usuario, $clave)) {

	redirect("/error/AdminISP/clave_error.html");
	
} elsif ( (! $periodo) && ( (! $desde) && (! $hasta) )) {
    
	redirect("/error/AdminISP/falta_periodo.html");

} elsif ($periodo) {

	$where = " date_format(AcctStopTime, '%Y%m') = '".$periodo."'";
	$titulo = "en el periodo '$periodo'";
	

} elsif ( ($desde) && ($hasta) ) {

	$desde  .= "000000";
	$hasta  .= "235959";
        $where   = " AcctStopTime > ".$desde." AND AcctStopTime < ".$hasta;
	$titulo  = "desde '$desde' hasta '$hasta'";

}


if ($detallado) {

	$sqlquery .= "date_format(AcctStopTime, '%d/%m/%Y') AS dia,";
	$sqlquery .= "date_format(AcctStartTime, '%H:%i:%S') AS inicio,";
	$sqlquery .= "date_format(AcctStopTime, '%H:%i:%S') AS fin ";
	$sqlquery .= "FROM radacct ";
	$sqlquery .= "WHERE ".$where." ";
	$sqlquery .= "AND username='".$usuario."' ";
	$sqlquery .= "GROUP BY dia,fin ORDER by dia,inicio";

} else {

	$sqlquery .= "date_format(AcctStopTime, '%d/%m/%Y') AS dia ";
	$sqlquery .= "FROM radacct ";
	$sqlquery .= "WHERE ".$where." ";
	$sqlquery .= "AND username='".$usuario."' ";
	$sqlquery .= "GROUP BY dia";

}


$sth	= $dbh->prepare($sqlquery);
$rv		= $sth->execute;

#print "$sqlquery<br><br>";



my $titulo	= "Consumos de '$usuario' ".$titulo;
my $total	= 0;
my $HTML	= "";

$HTML .= "<table align=center border=0 cellpadding=1 cellspacing=0>";



if ($detallado) {

	$titulo	.= " (detallado)";
	$HTML	.= "<tr><td colspan=4>$titulo</td></tr>";
	$HTML	.= "<tr><td colspan=4>&nbsp;</td></tr>";

	while (my ($minutos, $segundos, $hms, $dia, $inicio, $fin) = $sth->fetchrow_array) {
		$HTML	.= "<tr><td>$dia</td><td>$inicio</td><td>$fin</td><td>$hms</td></tr>";
		$total	 = $total + $minutos; 
	}

	$HTML	.= "<tr><td colspan=4>&nbsp;</td></tr>";
	$HTML	.= "<tr><td colspan=3 align=right>Total Minutos:</td><td>$total</td></tr>";

} else {

	$HTML	.= "<tr><td colspan=2>$titulo</td></tr>";
	$HTML	.= "<tr><td colspan=2>&nbsp;</td></tr>";

	while (my ($minutos, $segundos, $hms, $dia) = $sth->fetchrow_array) {
		$HTML	 .= "<tr><td>$dia</td><td>$hms</td>";
		$total	 = $total + $minutos; 
        }

	$HTML	.= "<tr><td colspan=2>&nbsp;</td></tr>";
	$HTML	.= "<tr><td align=right>Total Minutos:</td><td>$total</td></tr>";


	if (($periodo) && ($costo)) {

		my ($nombre_de_abono, $abono, $minutos_excedentes, $costo_excedente) = Excedentes ($usuario, $total);
		my $costo_total = $abono + $costo_excedente;
		
		$HTML   .= "<tr><td align=right>Total a Abonar:</td><td>$costo_total</td></tr>";

	}




}


$HTML .= "</table>";

print $HTML;








sub Excedentes {

    my $user                = shift;
    my $minutos_consumidos  = shift;
    
    my $id = 1;
    
    my $sth1    = $dbh->prepare("SELECT abono_id FROM dialup_users WHERE username=?");
    $rv         = $sth1->execute($user);
    $id         = $sth1->fetchrow_array();
    
    $sth1   = $dbh->prepare("SELECT nombre,tiempo,abono,excedente FROM abonos WHERE id=?");
    $rv     = $sth1->execute($id);
    ($nombre_de_abono, $minutos_disponibles, $abono, $costo_minuto_excedente) = $sth1->fetchrow_array();
    
    my $minutos_excedentes  = 0;
    my $costo_excedente     = 0.00;
    
    if (($minutos_disponibles >= 0) && ($minutos_consumidos > $minutos_disponibles)) {
        $minutos_excedentes = $minutos_consumidos - $minutos_disponibles;
        $costo_excedente = $costo_minuto_excedente * $minutos_excedentes;
    }   
    
    ($nombre_de_abono, $abono, $minutos_excedentes, $costo_excedente);
    
}











